

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkX11.Objects.X11AppLaunchContext
    ( 

-- * Exported types
    X11AppLaunchContext(..)                 ,
    IsX11AppLaunchContext                   ,
    toX11AppLaunchContext                   ,
    noX11AppLaunchContext                   ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gdk.Objects.AppLaunchContext as Gdk.AppLaunchContext
import qualified GI.Gio.Objects.AppLaunchContext as Gio.AppLaunchContext

-- | Memory-managed wrapper type.
newtype X11AppLaunchContext = X11AppLaunchContext (ManagedPtr X11AppLaunchContext)
foreign import ccall "gdk_x11_app_launch_context_get_type"
    c_gdk_x11_app_launch_context_get_type :: IO GType

instance GObject X11AppLaunchContext where
    gobjectType = c_gdk_x11_app_launch_context_get_type
    

-- | Type class for types which can be safely cast to `X11AppLaunchContext`, for instance with `toX11AppLaunchContext`.
class (GObject o, O.IsDescendantOf X11AppLaunchContext o) => IsX11AppLaunchContext o
instance (GObject o, O.IsDescendantOf X11AppLaunchContext o) => IsX11AppLaunchContext o

instance O.HasParentTypes X11AppLaunchContext
type instance O.ParentTypes X11AppLaunchContext = '[Gdk.AppLaunchContext.AppLaunchContext, Gio.AppLaunchContext.AppLaunchContext, GObject.Object.Object]

-- | Cast to `X11AppLaunchContext`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toX11AppLaunchContext :: (MonadIO m, IsX11AppLaunchContext o) => o -> m X11AppLaunchContext
toX11AppLaunchContext = liftIO . unsafeCastTo X11AppLaunchContext

-- | A convenience alias for `Nothing` :: `Maybe` `X11AppLaunchContext`.
noX11AppLaunchContext :: Maybe X11AppLaunchContext
noX11AppLaunchContext = Nothing

#if ENABLE_OVERLOADING
type family ResolveX11AppLaunchContextMethod (t :: Symbol) (o :: *) :: * where
    ResolveX11AppLaunchContextMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveX11AppLaunchContextMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveX11AppLaunchContextMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveX11AppLaunchContextMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveX11AppLaunchContextMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveX11AppLaunchContextMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveX11AppLaunchContextMethod "launchFailed" o = Gio.AppLaunchContext.AppLaunchContextLaunchFailedMethodInfo
    ResolveX11AppLaunchContextMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveX11AppLaunchContextMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveX11AppLaunchContextMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveX11AppLaunchContextMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveX11AppLaunchContextMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveX11AppLaunchContextMethod "setenv" o = Gio.AppLaunchContext.AppLaunchContextSetenvMethodInfo
    ResolveX11AppLaunchContextMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveX11AppLaunchContextMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveX11AppLaunchContextMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveX11AppLaunchContextMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveX11AppLaunchContextMethod "unsetenv" o = Gio.AppLaunchContext.AppLaunchContextUnsetenvMethodInfo
    ResolveX11AppLaunchContextMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveX11AppLaunchContextMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveX11AppLaunchContextMethod "getDisplay" o = Gio.AppLaunchContext.AppLaunchContextGetDisplayMethodInfo
    ResolveX11AppLaunchContextMethod "getEnvironment" o = Gio.AppLaunchContext.AppLaunchContextGetEnvironmentMethodInfo
    ResolveX11AppLaunchContextMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveX11AppLaunchContextMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveX11AppLaunchContextMethod "getStartupNotifyId" o = Gio.AppLaunchContext.AppLaunchContextGetStartupNotifyIdMethodInfo
    ResolveX11AppLaunchContextMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveX11AppLaunchContextMethod "setDesktop" o = Gdk.AppLaunchContext.AppLaunchContextSetDesktopMethodInfo
    ResolveX11AppLaunchContextMethod "setDisplay" o = Gdk.AppLaunchContext.AppLaunchContextSetDisplayMethodInfo
    ResolveX11AppLaunchContextMethod "setIcon" o = Gdk.AppLaunchContext.AppLaunchContextSetIconMethodInfo
    ResolveX11AppLaunchContextMethod "setIconName" o = Gdk.AppLaunchContext.AppLaunchContextSetIconNameMethodInfo
    ResolveX11AppLaunchContextMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveX11AppLaunchContextMethod "setScreen" o = Gdk.AppLaunchContext.AppLaunchContextSetScreenMethodInfo
    ResolveX11AppLaunchContextMethod "setTimestamp" o = Gdk.AppLaunchContext.AppLaunchContextSetTimestampMethodInfo
    ResolveX11AppLaunchContextMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveX11AppLaunchContextMethod t X11AppLaunchContext, O.MethodInfo info X11AppLaunchContext p) => OL.IsLabel t (X11AppLaunchContext -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList X11AppLaunchContext
type instance O.AttributeList X11AppLaunchContext = X11AppLaunchContextAttributeList
type X11AppLaunchContextAttributeList = ('[ '("display", Gdk.AppLaunchContext.AppLaunchContextDisplayPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList X11AppLaunchContext = X11AppLaunchContextSignalList
type X11AppLaunchContextSignalList = ('[ '("launchFailed", Gio.AppLaunchContext.AppLaunchContextLaunchFailedSignalInfo), '("launched", Gio.AppLaunchContext.AppLaunchContextLaunchedSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


