

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkX11.Objects.X11DeviceCore
    ( 

-- * Exported types
    X11DeviceCore(..)                       ,
    IsX11DeviceCore                         ,
    toX11DeviceCore                         ,
    noX11DeviceCore                         ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gdk.Objects.Device as Gdk.Device

-- | Memory-managed wrapper type.
newtype X11DeviceCore = X11DeviceCore (ManagedPtr X11DeviceCore)
foreign import ccall "gdk_x11_device_core_get_type"
    c_gdk_x11_device_core_get_type :: IO GType

instance GObject X11DeviceCore where
    gobjectType = c_gdk_x11_device_core_get_type
    

-- | Type class for types which can be safely cast to `X11DeviceCore`, for instance with `toX11DeviceCore`.
class (GObject o, O.IsDescendantOf X11DeviceCore o) => IsX11DeviceCore o
instance (GObject o, O.IsDescendantOf X11DeviceCore o) => IsX11DeviceCore o

instance O.HasParentTypes X11DeviceCore
type instance O.ParentTypes X11DeviceCore = '[Gdk.Device.Device, GObject.Object.Object]

-- | Cast to `X11DeviceCore`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toX11DeviceCore :: (MonadIO m, IsX11DeviceCore o) => o -> m X11DeviceCore
toX11DeviceCore = liftIO . unsafeCastTo X11DeviceCore

-- | A convenience alias for `Nothing` :: `Maybe` `X11DeviceCore`.
noX11DeviceCore :: Maybe X11DeviceCore
noX11DeviceCore = Nothing

#if ENABLE_OVERLOADING
type family ResolveX11DeviceCoreMethod (t :: Symbol) (o :: *) :: * where
    ResolveX11DeviceCoreMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveX11DeviceCoreMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveX11DeviceCoreMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveX11DeviceCoreMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveX11DeviceCoreMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveX11DeviceCoreMethod "grab" o = Gdk.Device.DeviceGrabMethodInfo
    ResolveX11DeviceCoreMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveX11DeviceCoreMethod "listAxes" o = Gdk.Device.DeviceListAxesMethodInfo
    ResolveX11DeviceCoreMethod "listSlaveDevices" o = Gdk.Device.DeviceListSlaveDevicesMethodInfo
    ResolveX11DeviceCoreMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveX11DeviceCoreMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveX11DeviceCoreMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveX11DeviceCoreMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveX11DeviceCoreMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveX11DeviceCoreMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveX11DeviceCoreMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveX11DeviceCoreMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveX11DeviceCoreMethod "ungrab" o = Gdk.Device.DeviceUngrabMethodInfo
    ResolveX11DeviceCoreMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveX11DeviceCoreMethod "warp" o = Gdk.Device.DeviceWarpMethodInfo
    ResolveX11DeviceCoreMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveX11DeviceCoreMethod "getAssociatedDevice" o = Gdk.Device.DeviceGetAssociatedDeviceMethodInfo
    ResolveX11DeviceCoreMethod "getAxes" o = Gdk.Device.DeviceGetAxesMethodInfo
    ResolveX11DeviceCoreMethod "getAxisUse" o = Gdk.Device.DeviceGetAxisUseMethodInfo
    ResolveX11DeviceCoreMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveX11DeviceCoreMethod "getDeviceType" o = Gdk.Device.DeviceGetDeviceTypeMethodInfo
    ResolveX11DeviceCoreMethod "getDisplay" o = Gdk.Device.DeviceGetDisplayMethodInfo
    ResolveX11DeviceCoreMethod "getHasCursor" o = Gdk.Device.DeviceGetHasCursorMethodInfo
    ResolveX11DeviceCoreMethod "getKey" o = Gdk.Device.DeviceGetKeyMethodInfo
    ResolveX11DeviceCoreMethod "getLastEventWindow" o = Gdk.Device.DeviceGetLastEventWindowMethodInfo
    ResolveX11DeviceCoreMethod "getMode" o = Gdk.Device.DeviceGetModeMethodInfo
    ResolveX11DeviceCoreMethod "getNAxes" o = Gdk.Device.DeviceGetNAxesMethodInfo
    ResolveX11DeviceCoreMethod "getNKeys" o = Gdk.Device.DeviceGetNKeysMethodInfo
    ResolveX11DeviceCoreMethod "getName" o = Gdk.Device.DeviceGetNameMethodInfo
    ResolveX11DeviceCoreMethod "getPosition" o = Gdk.Device.DeviceGetPositionMethodInfo
    ResolveX11DeviceCoreMethod "getPositionDouble" o = Gdk.Device.DeviceGetPositionDoubleMethodInfo
    ResolveX11DeviceCoreMethod "getProductId" o = Gdk.Device.DeviceGetProductIdMethodInfo
    ResolveX11DeviceCoreMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveX11DeviceCoreMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveX11DeviceCoreMethod "getSeat" o = Gdk.Device.DeviceGetSeatMethodInfo
    ResolveX11DeviceCoreMethod "getSource" o = Gdk.Device.DeviceGetSourceMethodInfo
    ResolveX11DeviceCoreMethod "getVendorId" o = Gdk.Device.DeviceGetVendorIdMethodInfo
    ResolveX11DeviceCoreMethod "getWindowAtPosition" o = Gdk.Device.DeviceGetWindowAtPositionMethodInfo
    ResolveX11DeviceCoreMethod "getWindowAtPositionDouble" o = Gdk.Device.DeviceGetWindowAtPositionDoubleMethodInfo
    ResolveX11DeviceCoreMethod "setAxisUse" o = Gdk.Device.DeviceSetAxisUseMethodInfo
    ResolveX11DeviceCoreMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveX11DeviceCoreMethod "setKey" o = Gdk.Device.DeviceSetKeyMethodInfo
    ResolveX11DeviceCoreMethod "setMode" o = Gdk.Device.DeviceSetModeMethodInfo
    ResolveX11DeviceCoreMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveX11DeviceCoreMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveX11DeviceCoreMethod t X11DeviceCore, O.MethodInfo info X11DeviceCore p) => OL.IsLabel t (X11DeviceCore -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList X11DeviceCore
type instance O.AttributeList X11DeviceCore = X11DeviceCoreAttributeList
type X11DeviceCoreAttributeList = ('[ '("associatedDevice", Gdk.Device.DeviceAssociatedDevicePropertyInfo), '("axes", Gdk.Device.DeviceAxesPropertyInfo), '("deviceManager", Gdk.Device.DeviceDeviceManagerPropertyInfo), '("display", Gdk.Device.DeviceDisplayPropertyInfo), '("hasCursor", Gdk.Device.DeviceHasCursorPropertyInfo), '("inputMode", Gdk.Device.DeviceInputModePropertyInfo), '("inputSource", Gdk.Device.DeviceInputSourcePropertyInfo), '("nAxes", Gdk.Device.DeviceNAxesPropertyInfo), '("name", Gdk.Device.DeviceNamePropertyInfo), '("numTouches", Gdk.Device.DeviceNumTouchesPropertyInfo), '("productId", Gdk.Device.DeviceProductIdPropertyInfo), '("seat", Gdk.Device.DeviceSeatPropertyInfo), '("tool", Gdk.Device.DeviceToolPropertyInfo), '("type", Gdk.Device.DeviceTypePropertyInfo), '("vendorId", Gdk.Device.DeviceVendorIdPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList X11DeviceCore = X11DeviceCoreSignalList
type X11DeviceCoreSignalList = ('[ '("changed", Gdk.Device.DeviceChangedSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("toolChanged", Gdk.Device.DeviceToolChangedSignalInfo)] :: [(Symbol, *)])

#endif


