

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkX11.Objects.X11DeviceManagerCore
    ( 

-- * Exported types
    X11DeviceManagerCore(..)                ,
    IsX11DeviceManagerCore                  ,
    toX11DeviceManagerCore                  ,
    noX11DeviceManagerCore                  ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gdk.Objects.DeviceManager as Gdk.DeviceManager

-- | Memory-managed wrapper type.
newtype X11DeviceManagerCore = X11DeviceManagerCore (ManagedPtr X11DeviceManagerCore)
foreign import ccall "gdk_x11_device_manager_core_get_type"
    c_gdk_x11_device_manager_core_get_type :: IO GType

instance GObject X11DeviceManagerCore where
    gobjectType = c_gdk_x11_device_manager_core_get_type
    

-- | Type class for types which can be safely cast to `X11DeviceManagerCore`, for instance with `toX11DeviceManagerCore`.
class (GObject o, O.IsDescendantOf X11DeviceManagerCore o) => IsX11DeviceManagerCore o
instance (GObject o, O.IsDescendantOf X11DeviceManagerCore o) => IsX11DeviceManagerCore o

instance O.HasParentTypes X11DeviceManagerCore
type instance O.ParentTypes X11DeviceManagerCore = '[Gdk.DeviceManager.DeviceManager, GObject.Object.Object]

-- | Cast to `X11DeviceManagerCore`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toX11DeviceManagerCore :: (MonadIO m, IsX11DeviceManagerCore o) => o -> m X11DeviceManagerCore
toX11DeviceManagerCore = liftIO . unsafeCastTo X11DeviceManagerCore

-- | A convenience alias for `Nothing` :: `Maybe` `X11DeviceManagerCore`.
noX11DeviceManagerCore :: Maybe X11DeviceManagerCore
noX11DeviceManagerCore = Nothing

#if ENABLE_OVERLOADING
type family ResolveX11DeviceManagerCoreMethod (t :: Symbol) (o :: *) :: * where
    ResolveX11DeviceManagerCoreMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveX11DeviceManagerCoreMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveX11DeviceManagerCoreMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveX11DeviceManagerCoreMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveX11DeviceManagerCoreMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveX11DeviceManagerCoreMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveX11DeviceManagerCoreMethod "listDevices" o = Gdk.DeviceManager.DeviceManagerListDevicesMethodInfo
    ResolveX11DeviceManagerCoreMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveX11DeviceManagerCoreMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveX11DeviceManagerCoreMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveX11DeviceManagerCoreMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveX11DeviceManagerCoreMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveX11DeviceManagerCoreMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveX11DeviceManagerCoreMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveX11DeviceManagerCoreMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveX11DeviceManagerCoreMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveX11DeviceManagerCoreMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveX11DeviceManagerCoreMethod "getClientPointer" o = Gdk.DeviceManager.DeviceManagerGetClientPointerMethodInfo
    ResolveX11DeviceManagerCoreMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveX11DeviceManagerCoreMethod "getDisplay" o = Gdk.DeviceManager.DeviceManagerGetDisplayMethodInfo
    ResolveX11DeviceManagerCoreMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveX11DeviceManagerCoreMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveX11DeviceManagerCoreMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveX11DeviceManagerCoreMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveX11DeviceManagerCoreMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveX11DeviceManagerCoreMethod t X11DeviceManagerCore, O.MethodInfo info X11DeviceManagerCore p) => OL.IsLabel t (X11DeviceManagerCore -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList X11DeviceManagerCore
type instance O.AttributeList X11DeviceManagerCore = X11DeviceManagerCoreAttributeList
type X11DeviceManagerCoreAttributeList = ('[ '("display", Gdk.DeviceManager.DeviceManagerDisplayPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList X11DeviceManagerCore = X11DeviceManagerCoreSignalList
type X11DeviceManagerCoreSignalList = ('[ '("deviceAdded", Gdk.DeviceManager.DeviceManagerDeviceAddedSignalInfo), '("deviceChanged", Gdk.DeviceManager.DeviceManagerDeviceChangedSignalInfo), '("deviceRemoved", Gdk.DeviceManager.DeviceManagerDeviceRemovedSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


