

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkX11.Objects.X11DisplayManager
    ( 

-- * Exported types
    X11DisplayManager(..)                   ,
    IsX11DisplayManager                     ,
    toX11DisplayManager                     ,
    noX11DisplayManager                     ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gdk.Objects.DisplayManager as Gdk.DisplayManager

-- | Memory-managed wrapper type.
newtype X11DisplayManager = X11DisplayManager (ManagedPtr X11DisplayManager)
foreign import ccall "gdk_x11_display_manager_get_type"
    c_gdk_x11_display_manager_get_type :: IO GType

instance GObject X11DisplayManager where
    gobjectType = c_gdk_x11_display_manager_get_type
    

-- | Type class for types which can be safely cast to `X11DisplayManager`, for instance with `toX11DisplayManager`.
class (GObject o, O.IsDescendantOf X11DisplayManager o) => IsX11DisplayManager o
instance (GObject o, O.IsDescendantOf X11DisplayManager o) => IsX11DisplayManager o

instance O.HasParentTypes X11DisplayManager
type instance O.ParentTypes X11DisplayManager = '[Gdk.DisplayManager.DisplayManager, GObject.Object.Object]

-- | Cast to `X11DisplayManager`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toX11DisplayManager :: (MonadIO m, IsX11DisplayManager o) => o -> m X11DisplayManager
toX11DisplayManager = liftIO . unsafeCastTo X11DisplayManager

-- | A convenience alias for `Nothing` :: `Maybe` `X11DisplayManager`.
noX11DisplayManager :: Maybe X11DisplayManager
noX11DisplayManager = Nothing

#if ENABLE_OVERLOADING
type family ResolveX11DisplayManagerMethod (t :: Symbol) (o :: *) :: * where
    ResolveX11DisplayManagerMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveX11DisplayManagerMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveX11DisplayManagerMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveX11DisplayManagerMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveX11DisplayManagerMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveX11DisplayManagerMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveX11DisplayManagerMethod "listDisplays" o = Gdk.DisplayManager.DisplayManagerListDisplaysMethodInfo
    ResolveX11DisplayManagerMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveX11DisplayManagerMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveX11DisplayManagerMethod "openDisplay" o = Gdk.DisplayManager.DisplayManagerOpenDisplayMethodInfo
    ResolveX11DisplayManagerMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveX11DisplayManagerMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveX11DisplayManagerMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveX11DisplayManagerMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveX11DisplayManagerMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveX11DisplayManagerMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveX11DisplayManagerMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveX11DisplayManagerMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveX11DisplayManagerMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveX11DisplayManagerMethod "getDefaultDisplay" o = Gdk.DisplayManager.DisplayManagerGetDefaultDisplayMethodInfo
    ResolveX11DisplayManagerMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveX11DisplayManagerMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveX11DisplayManagerMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveX11DisplayManagerMethod "setDefaultDisplay" o = Gdk.DisplayManager.DisplayManagerSetDefaultDisplayMethodInfo
    ResolveX11DisplayManagerMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveX11DisplayManagerMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveX11DisplayManagerMethod t X11DisplayManager, O.MethodInfo info X11DisplayManager p) => OL.IsLabel t (X11DisplayManager -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList X11DisplayManager
type instance O.AttributeList X11DisplayManager = X11DisplayManagerAttributeList
type X11DisplayManagerAttributeList = ('[ '("defaultDisplay", Gdk.DisplayManager.DisplayManagerDefaultDisplayPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList X11DisplayManager = X11DisplayManagerSignalList
type X11DisplayManagerSignalList = ('[ '("displayOpened", Gdk.DisplayManager.DisplayManagerDisplayOpenedSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


