

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GdkX11.Objects.X11GLContext
    ( 

-- * Exported types
    X11GLContext(..)                        ,
    IsX11GLContext                          ,
    toX11GLContext                          ,
    noX11GLContext                          ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gdk.Objects.GLContext as Gdk.GLContext

-- | Memory-managed wrapper type.
newtype X11GLContext = X11GLContext (ManagedPtr X11GLContext)
foreign import ccall "gdk_x11_gl_context_get_type"
    c_gdk_x11_gl_context_get_type :: IO GType

instance GObject X11GLContext where
    gobjectType = c_gdk_x11_gl_context_get_type
    

-- | Type class for types which can be safely cast to `X11GLContext`, for instance with `toX11GLContext`.
class (GObject o, O.IsDescendantOf X11GLContext o) => IsX11GLContext o
instance (GObject o, O.IsDescendantOf X11GLContext o) => IsX11GLContext o

instance O.HasParentTypes X11GLContext
type instance O.ParentTypes X11GLContext = '[Gdk.GLContext.GLContext, GObject.Object.Object]

-- | Cast to `X11GLContext`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toX11GLContext :: (MonadIO m, IsX11GLContext o) => o -> m X11GLContext
toX11GLContext = liftIO . unsafeCastTo X11GLContext

-- | A convenience alias for `Nothing` :: `Maybe` `X11GLContext`.
noX11GLContext :: Maybe X11GLContext
noX11GLContext = Nothing

#if ENABLE_OVERLOADING
type family ResolveX11GLContextMethod (t :: Symbol) (o :: *) :: * where
    ResolveX11GLContextMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveX11GLContextMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveX11GLContextMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveX11GLContextMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveX11GLContextMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveX11GLContextMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveX11GLContextMethod "isLegacy" o = Gdk.GLContext.GLContextIsLegacyMethodInfo
    ResolveX11GLContextMethod "makeCurrent" o = Gdk.GLContext.GLContextMakeCurrentMethodInfo
    ResolveX11GLContextMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveX11GLContextMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveX11GLContextMethod "realize" o = Gdk.GLContext.GLContextRealizeMethodInfo
    ResolveX11GLContextMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveX11GLContextMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveX11GLContextMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveX11GLContextMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveX11GLContextMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveX11GLContextMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveX11GLContextMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveX11GLContextMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveX11GLContextMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveX11GLContextMethod "getDebugEnabled" o = Gdk.GLContext.GLContextGetDebugEnabledMethodInfo
    ResolveX11GLContextMethod "getDisplay" o = Gdk.GLContext.GLContextGetDisplayMethodInfo
    ResolveX11GLContextMethod "getForwardCompatible" o = Gdk.GLContext.GLContextGetForwardCompatibleMethodInfo
    ResolveX11GLContextMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveX11GLContextMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveX11GLContextMethod "getRequiredVersion" o = Gdk.GLContext.GLContextGetRequiredVersionMethodInfo
    ResolveX11GLContextMethod "getSharedContext" o = Gdk.GLContext.GLContextGetSharedContextMethodInfo
    ResolveX11GLContextMethod "getUseEs" o = Gdk.GLContext.GLContextGetUseEsMethodInfo
    ResolveX11GLContextMethod "getVersion" o = Gdk.GLContext.GLContextGetVersionMethodInfo
    ResolveX11GLContextMethod "getWindow" o = Gdk.GLContext.GLContextGetWindowMethodInfo
    ResolveX11GLContextMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveX11GLContextMethod "setDebugEnabled" o = Gdk.GLContext.GLContextSetDebugEnabledMethodInfo
    ResolveX11GLContextMethod "setForwardCompatible" o = Gdk.GLContext.GLContextSetForwardCompatibleMethodInfo
    ResolveX11GLContextMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveX11GLContextMethod "setRequiredVersion" o = Gdk.GLContext.GLContextSetRequiredVersionMethodInfo
    ResolveX11GLContextMethod "setUseEs" o = Gdk.GLContext.GLContextSetUseEsMethodInfo
    ResolveX11GLContextMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveX11GLContextMethod t X11GLContext, O.MethodInfo info X11GLContext p) => OL.IsLabel t (X11GLContext -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList X11GLContext
type instance O.AttributeList X11GLContext = X11GLContextAttributeList
type X11GLContextAttributeList = ('[ '("display", Gdk.GLContext.GLContextDisplayPropertyInfo), '("sharedContext", Gdk.GLContext.GLContextSharedContextPropertyInfo), '("window", Gdk.GLContext.GLContextWindowPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type instance O.SignalList X11GLContext = X11GLContextSignalList
type X11GLContextSignalList = ('[ '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif


